//
// Created by zx on 2020/7/16.
//

#ifndef NNXX_TESTS_PICKUP_TERMINAL_H
#define NNXX_TESTS_PICKUP_TERMINAL_H
#include <thread>
#include "threadSafeQueue.h"
#include "thread_condition.h"
#include "error_code.h"
#include "terminal_message.pb.h"

class pickup_terminal {
public:
    pickup_terminal(message::Car_info);
    ~pickup_terminal();

    Error_manager pickup(int terminal_id);
protected:

    message::Car_info           m_car_info;
    Thread_condition                                m_exit_cond;
};


#endif //NNXX_TESTS_PICKUP_TERMINAL_H
