//
// Created by zx on 2020/7/16.
//

#ifndef NNXX_TESTS_STORE_TERMINAL_H
#define NNXX_TESTS_STORE_TERMINAL_H
#include <thread>
#include "thread_condition.h"
#include "error_code.h"
#include "terminal_message.pb.h"
#include "threadSafeQueue.h"


class store_command
{

public:
    store_command(message::Car_info);
    ~store_command();

    Error_manager storing(int terminal_id);

protected:


    message::Car_info          m_car_info;
    Thread_condition                                m_exit_cond;
 public:
    static threadsafe_queue<message::Car_info>*        p_command_queue;

};


#endif //NNXX_TESTS_STORE_TERMINAL_H
